
#ifndef STREAM_INHO_H
#define STREAM_INHO_H

#include <stdlib.h> //wchar_t
#include <stdio.h>
#include <ole2.h>   //IStream, IStorage

class CStreamInfo
{
public:
	bool Packed; //  zLibEngine
	bool HaveSize; //     

	bool MainMetadataStream;

	unsigned long SizeOffset; //     -   0xFF
	unsigned long SizeBytes;  //    
	unsigned long ContentOffset; //  
	unsigned long FullSize;
	unsigned long Size; //    
	//  ,  MDS,   , -    , 
	//     
	unsigned long LastZeroBytes;

public:
	CStreamInfo();

	void UpdateInfo(LPCSTR StreamName);
	void UpdateInfo(const wchar_t* wStreamName);

	unsigned long ReadSize(IStream* pStream); //   (   )   
	unsigned long ReadSizeOfCleanStream(IStream* pStream); //   
	unsigned long ReadFileSize(FILE *File); //  
	unsigned long ReadSize(LPCSTR lpStr);
	unsigned long CountLastZeroBytes(IStream* pStream);
	unsigned long CountLastZeroBytes(FILE* File);

protected:
	void DetermineSizeFormat(unsigned long FullSize);
	void DetermineFileSizeFormat(unsigned long FullSize);

private:
	void Reset();
};

#endif